// RDMSampleView.cpp : implementation of the CRDMSampleView class
//

#include "stdafx.h"
#include "RDMSample.h"

#include "RDMSampleDoc.h"
#include "RDMSampleView.h"
#include "RegDocMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRDMSampleView

IMPLEMENT_DYNCREATE(CRDMSampleView, CView)

BEGIN_MESSAGE_MAP(CRDMSampleView, CView)
	//{{AFX_MSG_MAP(CRDMSampleView)
	ON_COMMAND(IDM_EXPORT, OnExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRDMSampleView construction/destruction

CRDMSampleView::CRDMSampleView()
{
	// TODO: add construction code here

}

CRDMSampleView::~CRDMSampleView()
{
}

BOOL CRDMSampleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CRDMSampleView drawing

void CRDMSampleView::OnDraw(CDC* pDC)
{
	CRDMSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CRDMSampleView diagnostics

#ifdef _DEBUG
void CRDMSampleView::AssertValid() const
{
	CView::AssertValid();
}

void CRDMSampleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CRDMSampleDoc* CRDMSampleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRDMSampleDoc)));
	return (CRDMSampleDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRDMSampleView message handlers

void CRDMSampleView::OnExport() 
{
	// setup for the EXPORT file dialog

	// for a probable title
	CRDMSampleDoc* pDoc = GetDocument();
	CString csTitle = pDoc->GetTitle();
	if (csTitle != "Untitled")
		csTitle = csTitle.Left(csTitle.GetLength() - 4);

	// file filters
	static char szFilter[] = "ABC Files (*.abc)|*.abc; *.abc|All Files (*.*)|*.*||";

	// create the dialog
	CFileDialog dlgExport(false, "abc", (LPCTSTR) csTitle,
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, AfxGetMainWnd());
	dlgExport.m_ofn.lpstrTitle = "Export to file"; // window title

	//	IMPORT
	//	static char szFilter[] = "ABC Files (*.abc)|*.abc; *.abc||";
	//	CFileDialog dlgImport(true, "abc", NULL, // no preset filename
	//			OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST, szFilter, AfxGetMainWnd());

	////////////////////////////////////////////////////////////////
	// set a starting directory if one exists
	CRegDocMgr* pDocMgr = (CRegDocMgr*) AfxGetApp()->m_pDocManager;
	dlgExport.m_ofn.lpstrInitialDir = pDocMgr->GetCurrentMRUD();
	////////////////////////////////////////////////////////////////

	// show it
	if (dlgExport.DoModal() == IDOK)
	{
		////////////////////////////////////////////////////////////////
		// omit this if import/export should not affect document MRUD
		pDocMgr->SetMRUD(dlgExport.m_ofn.lpstrFile);
		////////////////////////////////////////////////////////////////

		//... proceed with the import/export ... etc
		CFile export(dlgExport.m_ofn.lpstrFile, CFile::modeCreate | CFile::modeWrite);
		export.Write("test data", 9);
		export.Close();
	}
}
